﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	Function AgeDepthFit( )
		SetDataFolder root:
			PauseUpdate
			String/G G_Folder, G_AgeWave, G_DepthWave, G_EventWave, G_ZeroYorN, G_Site, G_CursorYorN, G_AgeOrDepth
			String Folder = G_Folder, AgeWave = G_AgeWave, EventWave = G_EventWave, DepthWave = G_DepthWave, AgeOrDepth = G_AgeOrDepth
			String CursorYorN = G_CursorYorN, ZeroYorN = G_ZeroYorN, Site = G_Site
			Variable/G G_PolyOrder
			Variable PolyOrder = G_PolyOrder			
			Prompt Site, "Site ( e.g. U1338 )"
			Prompt Folder, "Select the Data Folder with the Age-Depth Data", popup, "root:;" + SortList( FolderList( "*" ) )
			DoPrompt "AgeDepthFit", Site, Folder;
			G_Folder = Folder; G_Site = Site
			AbortOnValue V_Flag, 0
		SetDataFolder $Folder
			Prompt DepthWave, "DepthWave", popup, SortList( WaveList( "*", ";", "TEXT:0" ) )
			Prompt AgeWave, "AgeWave", popup, SortList( WaveList( "*", ";", "TEXT:0" ) )
			Prompt EventWave, "EventWave e.g. Species or Reversals", popup, "None;" + SortList( WaveList( "*", ";", "TEXT:1" ) ) // This is for the species or reversals
			Prompt PolyOrder, "Order of Fit ( 2 or greater )"
			Prompt ZeroYorN, "Do You Want to Force the Fit Through Zero Age at Zero Depth?", popup, "Yes;No"
			Prompt CursorYorN, "Do You Want to Fit only between Cursors A & B?", popup, "Yes;No"
			Prompt AgeOrDepth, "Do You Want Age or Depth as the X Axis?", popup, "Age;Depth"
			DoPrompt "SpectralAgeDepthFit", DepthWave, AgeWave, EventWave, PolyOrder, ZeroYorN, CursorYorN, AgeOrDepth
			G_DepthWave = DepthWave; G_AgeWave = AgeWave; G_PolyOrder = PolyOrder; G_EventWave = EventWave
			G_ZeroYorN = ZeroYorN; G_CursorYorN = CursorYorN; G_AgeOrDepth = AgeOrDepth			
			AbortOnValue V_Flag, 0
			Print "AgeDepthFit_F( " + "\"" + Site + "\", \"" + Folder + "\", \"" + DepthWave + "\", \"" + AgeWave + "\", \"" + EventWave + "\", " + Num2Str( PolyOrder ) + ", \"" + ZeroYorN + "\", \"" + CursorYorN + "\", \"" + AgeOrDepth + "\" )"
			AgeDepthFit_F( Site, Folder, DepthWave, AgeWave, EventWave,  PolyOrder  , ZeroYorN, CursorYorN, AgeOrDepth )
	End

----------------------------------------------------------------------

	Function AgeDepthFit_F( Site, Folder, DepthWave, AgeWave, EventWave, PolyOrder, ZeroYorN, CursorYorN, AgeOrDepth )
			String Site, Folder, AgeWave, DepthWave, EventWave, ZeroYorN, CursorYorN, AgeOrDepth
			Variable PolyOrder	
		SetDataFolder root:
			String/G G_Folder, G_AgeWave, G_DepthWave, G_ZeroYorN, G_Site, G_CursorYorN, G_AgeOrDepth
			Variable/G G_PolyOrder
			G_DepthWave = DepthWave; G_AgeWave = AgeWave; G_PolyOrder = PolyOrder
			G_ZeroYorN = ZeroYorN; G_CursorYorN = CursorYorN; G_AgeOrDepth = AgeOrDepth	
			NewDataFolder/O Xtras		
		SetDataFolder root:$Folder
			Wave DW = $DepthWave, AW = $AgeWave // DW and AW are the wave refs for depth and age
			If( StringMatch( EventWave, "None" ) )
				Make/T/O/N = ( NumPnts( DW ) ) ::Xtras:None
				WAVE/T EventWv = ::Xtras:None
			Else
				WAVE/T EventWv = $EventWave // The event wave has the species or reversal names. It has to be a text wave
			EndIf

			If( WaveType( DW, 1 ) == 2 || WaveType( AW, 1 ) == 2 ) // Check to see that the depth and age waves are numbers, not text
				SetDataFolder root: // If there is a problem go back to root: before aborting
				ABORT "Either " + AgeWave + " or " + DepthWave + " is a TEXT wave and can't be used for curve fitting.\r\rDelete the \"AgeDepthFit\" folder and run again."
			EndIf
			If( NumPnts( DW ) != NumPnts( AW ) ) // Check to see that depth and age waves are the same length
				SetDataFolder root: // If there is a problem go back to root: before aborting
				ABORT AgeWave + " does not have the same number of points as " + DepthWave
			EndIf
		NewDataFolder/O/S $"root:AgeDepthFit" // Shift to the default folder holding fit results
			Duplicate/O DW $Site + "_DepthWv" // Set up the depth, age, and weight waves for the fit. Each begins with the Site name
			Duplicate/O AW $Site + "_AgeWv"	
			Duplicate/O AW $Site + "_Weight"
			WAVE DepthWv = $Site + "_DepthWv", AgeWv = $Site + "_AgeWv", Weight = $Site + "_Weight" // wave refs for above
			Weight = 1 // Begin with all data weighted 1. Weight of 0 excludes a point
			Make/T/O/N = ( NumPnts( DepthWv ) ) $Site + "_DataTypeWv" // Create the text wave to hold data types 
			WAVE/T DataTypeWv = $Site + "_DataTypeWv", MultiDataType = $Site + "_DataType_4_Fit" // Wave ref for data type wave. The multi data waves are created using the AgeDataSelection function
			Make/T/O/N = ( NumPnts( DepthWv ) ) $Site + "_DataEventWv" // Create the text wave to hold data types 
			WAVE/T DataEventWv = $Site + "_DataEventWv", MultiEventType = $Site + "_DataEvent_4_Fit" // Wave refs for data Event wave. The multi data waves are created using the AgeDataSelection function
			If( WaveExists( MultiDataType ) && StringMatch( Folder, "AgeDepthFit" ) ) // Multi data waves are those formed by AgeDataSelection() from > 1 data set
				DataTypeWv = MultiDataType // Multi data waves are those formed by AgeDataSelection() from > 1 data set
				DataEventWv = MultiEventType				
			Else
				DataTypeWv = SecondPart( DepthWave ) // With only 1 age/depth data set the data type is the Technique of the depth wave
				DataEventWv = EventWv // With only 1 age/depth data set the Event wave is the wave selected at the start of the function
			EndIf
   			If( StringMatch( ZeroYorN, "Yes" ) ) // Inserts 0 depth and 0 age point pair at top of data to be fit and forces fit through that point
				InsertPoints 0, 1, DepthWv, AgeWv, Weight, DataTypeWv, DataEventWv
				DataTypeWv[0] = "Forced" // Sets the data type wave to Forced
				Weight[ 0 ] = 10 // The weight of the 0 depth and age point is set to 10 
				K0 = 0 // This sets the top of the fit to 0 depth/age
			EndIf
			Sort DepthWv DepthWv, AgeWv, Weight, DataTypeWv, DataEventWv // Sort the data by depth. Mostly changes the multi-dataset waves
			If( StringMatch( CursorYorN, "No" ) )  // Don't use cursors
				If( StringMatch( AgeOrDepth, "Age" )) // This section is for data plotted with the Age axis on the bottom
					If( StrSearch( WinList( "*", ";", "Visible:1,WIN:1" ), "Poly_Fit_OnAge", 0 ) < 0 ) // Check to see if data are plotted already
						Display/N = Poly_Fit_OnAge /W = ( 431, 45, 952, 526 ) /B = AgeAxis /L = DepthAxis DepthWv vs AgeWv	as "Poly Fit On Age"	// Plot data on graph named Poly_Fit_OnAge
					Else
						EXECUTE "DoWindow/F Poly_Fit_OnAge" // If data are already plotted, bring plot to front
					EndIf
				Else
					If( StrSearch( WinList( "*", ";", "Visible:1,WIN:1" ), "Poly_Fit_OnDepth", 0 ) < 0 ) // Check to see if data are plotted already
						Display/N = Poly_Fit_OnDepth /W = ( 451, 65, 972, 546 ) /B = AgeAxis /L = DepthAxis DepthWv vs AgeWv	as "Poly Fit On Depth"	// Plot dataon graph named Poly_Fit_OnDepth
					Else
						EXECUTE "DoWindow/F Poly_Fit_OnDepth" // If data are already plotted, bring plot to front
					EndIf
				EndIf	
				If( StringMatch( ZeroYorN, "Yes" ) ) // No cursors and force fit through 0
					If( PolyOrder == 2 ) // Distinct command for linear fit
						CurveFit/Q/L=500/H="10" line, DepthWv /X=AgeWv /D /W = Weight  // Distinct command for linear fit
					Else // Command for all higher order fits
						CurveFit/Q/L=500/H="1000000000000" poly PolyOrder, DepthWv /X=AgeWv /D /W = Weight // Command for all higher order fits
					EndIf
				Else // No cursors and don't force fit through 0
					If( PolyOrder == 2 ) // Distinct command for linear fit
						CurveFit/Q/L=500 line, DepthWv /X=AgeWv /D /W = Weight	 // Distinct command for linear fit	
					Else // Command for all higher order fits
						CurveFit/Q/L=500 poly PolyOrder, DepthWv /X=AgeWv /D /W = Weight // Command for all higher order fits
					EndIf
				EndIf
				WAVE W_coef	// The coef wave holds the coefficients for the fitted wave		
			Else // Use Cursors
				If( StrSearch( WinList( "*", ";", "Visible:1,WIN:1" ), "Poly_Fit_OnAge", 0 ) < 0  && StrSearch( WinList( "*", ";", "Visible:1,WIN:1" ), "Poly_Fit_OnDepth", 0 ) < 0 ) // If the data are not plotted, cursors cannot be evaluated
					ABORT "In order to use the cursors the data must first be plotted.\r\rRun the function without cursors first, then add them and run again."
				EndIf		
				If( !StringMatch( CsrWave( A ), NameOfWave(DepthWv) ) ||  !StringMatch( CsrWave( B ), NameOfWave(DepthWv) ) ) // Check to see if cursors are on data points, not fit or sed rate curves
					ABORT "One or both Cursors are not on the data.\r\rPerhaps they are on the fit line instead?"
				EndIf
				If( StringMatch( ZeroYorN, "Yes" ) ) // Use cursors and force fit through 0
					If( PolyOrder == 2 )
						CurveFit/Q/L=500/H="10" line, DepthWv[ PCsr( A ), PCsr( B ) ] /X=AgeWv[ PCsr( A ), PCsr( B ) ] /D /W = Weight // Special case of linear ( 2nd order ) fit
					Else
						CurveFit/Q/L=500/H="1000000000000" poly PolyOrder, DepthWv[ PCsr( A ), PCsr( B ) ] /X=AgeWv[ PCsr( A ), PCsr( B ) ] /D /W = Weight // For all higher order fits
					Endif
				Else // Use cursors and don't force through 0
					If( PolyOrder == 2 )
						CurveFit/Q/L=500 line, DepthWv[ PCsr( A ), PCsr( B ) ] /X=AgeWv[ PCsr( A ), PCsr( B ) ] /D /W = Weight	 // Special case of linear ( 2nd order ) fit	
					Else
						CurveFit/Q/L=500 poly PolyOrder, DepthWv[ PCsr( A ), PCsr( B ) ] /X=AgeWv[ PCsr( A ), PCsr( B ) ] /D /W = Weight // For all higher order fits
					EndIf
				EndIf
				WAVE W_coef	// The coef wave holds the coefficients for the fitted wave			
			EndIf
			Duplicate/O W_coef $"fit_" + Site + "_Coefs" // Save the coefficient wave with unique name
			Duplicate/O $"fit_" + Site + "_DepthWv" $"fit_" + Site + "_AgeWv", $Site + "_SedRateDepth" // Make an age wave for the fit and a depth wave for the sed rate
			WAVE AgeFit = $"fit_" + Site + "_AgeWv", DepthFit = $"fit_" + Site + "_DepthWv" // wave refs for default-named fit waves formed as part of the CurveFit function
			WAVE SedRateDepth = $Site + "_SedRateDepth" // Wave ref for sed rate depth wave
			If( CheckAgeModel( AgeFit, DepthFit ) == 0 ) // Warn user if the fit curve does not increase monotonically
				DoAlert/T="Age Model Warning", 0, "The age/depth fit is recurved ( negative sed rates ).\r\rThis may cause a problem when converting depth to age.\r\r Either rerun with a different Order of fit or hand edit the fit curves."
			EndIf
			Differentiate DepthFit /D = $Site + "_SedRate" // The differential of the age/depth fit is the sed rate
			WAVE SedRate = $Site + "_SedRate" // Wave ref for the sed rate curve
			If( PolyOrder == 2 )
				SedRate = ( Round( SedRate * 10 ) ) /10 // For linear fits the constant sedimentation rate is rounded off. Otherwise it may plot with some 6 decimal place value as the only tick on the axis
			EndIf
			If( StrSearch( TraceNameList( "", ";", 1 ), "SedRateDepth", 0 ) < 0 ) // Check to see if the sed rate is already plotted on the graph
				AppendToGraph/T = SedRateAxis/L = DepthAxis SedRateDepth vs SedRate // add sed rate on its own top axis
				Label SedRateAxis "SedRate m/Myr"
				ModifyGraph axisEnab(SedRateAxis)={0.5,1}
				ModifyGraph rgb($NameOfWave(SedRateDepth))=(65535,43690,0)
			EndIf 
			AgeFit = x // Set the Age fit wave to the x scaling of the fit wave
			SetAxis AgeAxis 0,* // Start the Age axis at 0
			SetAxis/R DepthAxis *,0 // Reverse the depth axis
			ModifyGraph mode($Site + "_DepthWv")=3,marker($Site + "_DepthWv")=19,msize($Site + "_DepthWv")=7
			ModifyGraph mrkThick($Site + "_DepthWv")=3, lsize = 2
			ModifyGraph freePos = 0
			ModifyGraph zColor( $Site + "_DepthWv" )={$Site + "_Weight",0,10,Rainbow16,1} // Set the color of the data points to vary as the weighting values
			Label DepthAxis "Depth";DelayUpdate
			Label AgeAxis "Age"
			ModifyGraph lblPos = 50
			ModifyGraph lblPosMode = 4
			ShowInfo
			Set_Cursors_Red()
			KillWaves/Z W_ParamConfidenceInterval, W_sigma, W_coef // Remove waves produced by CurveFit and no longer needed
			Duplicate/O/T DataTypeWv Temp // Copy the data type wave to temp for making a data type list
			Sort Temp Temp // Sort so that all of the data types are together in the wave
			String DataTypeList = ( Temp[ 0 ] + ";" ) // start the unique data type list with the first data type from the data type wave
			Variable i, NumberOfTypes = ItemsInList( DataTypeList )
			For( i = 0; i < NumPnts( Temp ); i += 1 ) // This loop sorts through the data type sorted list and looks for spots where the type changes
				NumberOfTypes = ItemsInList( DataTypeList ) // Go through the entire wave of data types				
				If( !StringMatch( Temp[ i ], StringFromList( NumberOfTypes - 1, DataTypeList ) ) ) // This is the comparison between 2 adjacent data types in the wave to see if the are different
					DataTypeList = DataTypeList + Temp[ i ] + ";"		// If the types of the 2 adjacent data points are different, the "new" type is added to the list of data unique typs			
				EndIf				
			EndFor		
			Killwaves/Z Temp // get rid of Temp
			String TypeString4Legend = ""	// Establish a blank string for the graph legend	
			Duplicate/O DepthWv $Site + "_Markers" // Establish a Marker wave 
			WAVE MarkerWv  = $Site + "_Markers" // Wave ref for the marker wave. Marker types are defined by numbers
			MarkerWv = 0 // Set all markers to 0 
			For( i = 0; i < ItemsInList( DataTypeList ); i += 1 ) // Work through each item in the data type list formed above
				MarkerWv = StringMatch( StringFromList( i, DataTypeList ), DataTypeWv ) ? i : MarkerWv // each data type is assined to a marker number = to i
				TypeString4Legend = TypeString4Legend + "\Z14\\W" + Num2Str( 8000 + i ) + " " + StringFromList( i, DataTypeList ) + "\r" // for each data type a new line is added to the Legend string. Look at the Legend to see how this works
			EndFor
				// Add a color bar to the plot using the Rainbow16 color scale
			ColorScale/C/N = ColorText/F = 0/B = 1/A = LB vert = 0, widthPct = 40, colorBoxesFrame=1, trace = $NameOfWave( DepthWv )
			ColorScale/C/N= ColorText fsize = 12,fstyle = 1, nticks = 10;
			ColorScale/C/N = ColorText "Weight"		
			ModifyGraph zmrkNum( $NameOfWave( DepthWv ) ) = { $Site + "_Markers" } // Set different data types to different symbols using the Marker wave			
		SetDataFolder root:
			If( StrSearch( WinList( "*", ";", "Visible:1" ), "FittingData", 0 ) < 0 ) // Check to see if a data table name "FittingData" is already open
				Edit/N = FittingData AgeWv, DepthWv, DataTypeWv, DataEventWv, Weight, MarkerWv // Make a data table named "FittingData" for these waves
				ModifyTable alignment=1
			EndIf			
			EXECUTE "DoWindow/F FittingData"	// Move the data table to the front	
			Legend/C/N=LegendText/J/F=0/B=1/A=MT 	TypeString4Legend // Add the Legend to the graph
			If( StringMatch( AgeOrDepth, "Depth" ) ) // Check to see which Axis should be the bottom
				DoWindow/Z/F Poly_Fit_OnDepth // Move Poly_Fit_OnDepth to the front			
				ModifyGraph swapXY = 1 // If depth is the bottom axis, swap the x and y axes
				ModifyGraph axisEnab(SedRateAxis)={0.25,0.75} // Chage the position of the sed rate axis
			EndIf		
			If( StrSearch( WinList( "*", ";", "Visible:1,WIN:1" ), "Poly_Fit_OnDepth", 0 ) >= 0 ) // Check to see if data are plotted already
				DoWindow/Z/F Poly_Fit_OnDepth // Move to front
				SetAxis DepthAxis *,* // Auto scale axes
				SetAxis/R AgeAxis *,*
			EndIf
			If( StrSearch( WinList( "*", ";", "Visible:1,WIN:1" ), "Poly_Fit_OnAge", 0 ) >= 0 ) // Check to see if data are plotted already
				DoWindow/Z/F Poly_Fit_OnAge // Move to front	
				SetAxis/R DepthAxis *,* // Auto scale axes
				SetAxis AgeAxis *,*
			EndIf
			KillWaves/Z :Xtras:None
			DoWindow/H // Return to the command line from the graph
	End
	
	---------------------------------------------------------------

	Function SetWeights()
		SetDataFolder root:AgeDepthFit
			String/G G_Site
			String Site = G_Site, DataTypeList
			Prompt Site, "Site"
			DoPrompt "SetWeights", Site;
			G_Site = Site
			AbortOnValue V_Flag, 0			
			Wave/T DataTypeWv = $Site + "_DataTypeWv" // ref for data type wave
			Wave WeightWave = $Site + "_Weight" // ref for data weighting wave
			Duplicate/O/T DataTypeWv Temp
			Sort Temp Temp
			DataTypeList = ( Temp[ 0 ] + ";" ) // start the data type list with the first data type
			Variable i, j, NumberOfTypes = ItemsInList( DataTypeList )
			For( i = 0; i < NumPnts( Temp ); i += 1 )
				NumberOfTypes = ItemsInList( DataTypeList )				
				If( !StringMatch( Temp[ i ], StringFromList( NumberOfTypes - 1, DataTypeList ) ) )
					DataTypeList = DataTypeList + Temp[ i ] + ";"					
				EndIf				
			EndFor
			String/G G_DataType
			String DataType = G_DataType
			Variable/G G_WeightValue
			Variable WeightValue = G_WeightValue
			Prompt DataType, "Select the data type for weight change", popup, DataTypeList
			Prompt WeightValue, "Enter the new weight"
			DoPrompt "SetWeights", DataType, WeightValue
			G_DataType = DataType, G_WeightValue = WeightValue
			AbortOnValue V_Flag, 0
			KillWaves/Z Temp
			Print "SetWeights_F( \"" + Site + "\", \"" + DataType + "\", " + Num2Str( WeightValue ) + " )"
			SetWeights_F( Site, DataType, WeightValue )
		SetDataFolder root:
	End

	---------------------------------------------------------------

	Function SetWeights_F( Site, DataType, WeightValue )
			String Site, DataType
			Variable WeightValue
		SetDataFolder root:AgeDepthFit
			String/G G_Site
			String  DataTypeList
			G_Site = Site
			Wave/T DataTypeWv = $Site + "_DataTypeWv" // ref for data type wave
			Wave WeightWave = $Site + "_Weight" // ref for data weighting wave
			Duplicate/O/T DataTypeWv Temp
			Sort Temp Temp
			DataTypeList = ( Temp[ 0 ] + ";" ) // start the data type list with the first data type
			Variable i, j, NumberOfTypes = ItemsInList( DataTypeList )
			For( i = 0; i < NumPnts( Temp ); i += 1 )
				NumberOfTypes = ItemsInList( DataTypeList )				
				If( !StringMatch( Temp[ i ], StringFromList( NumberOfTypes - 1, DataTypeList ) ) )
					DataTypeList = DataTypeList + Temp[ i ] + ";"					
				EndIf				
			EndFor
			String/G G_DataType
			Variable/G G_WeightValue
			G_DataType = DataType, G_WeightValue = WeightValue
			WeightWave = StringMatch( DataType, DataTypeWv ) ? WeightValue : WeightWave
			KillWaves/Z Temp
		SetDataFolder root:
	End

-------------------------------------------------------

	Function Weight_0()
		SetDataFolder root:AgeDepthFit
			Wave WeightWave = $FirstPart( CsrWave( A ) ) + "_Weight"
			Wave MarkerWave = $FirstPart( CsrWave( A ) ) + "_Markers"
			WeightWave[ PCsr( A ) ] = 0
			MarkerWave[ PCsr( A ) ] = 58
		SetDataFolder root:
	End	
	
-------------------------------------------------------


//	Function AgeDepthFit( )
		SetDataFolder root:
			PauseUpdate
			String/G G_Folder, G_AgeWave, G_DepthWave, G_YorN, G_Site
			String Folder = G_Folder, AgeWave = G_AgeWave, DepthWave = G_DepthWave, YorN = G_YorN, Site = G_Site
			Variable/G G_PolyOrder
			Variable PolyOrder = G_PolyOrder			
			Prompt Site, "Site ( e.g. U1338 )"
			Prompt Folder, "Select the Data Folder with the Age-Depth Data", popup, "root:;" + SortList( FolderList( "*" ) )
			DoPrompt "AgeDepthFit", Site, Folder;
			G_Folder = Folder; G_Site = Site
			AbortOnValue V_Flag, 0
		SetDataFolder $Folder
			Prompt DepthWave, "DepthWave", popup, SortList( WaveList( "*", ";", "" ) )
			Prompt AgeWave, "AgeWave", popup, SortList( WaveList( "*", ";", "" ) )
			Prompt PolyOrder, "Order of Fit ( 2 or greater )"
			Prompt YorN, "Do You Want to Force the Fit Through Zero Age at Zero Depth?", popup, "Yes;No"
			DoPrompt "AgeDepthFit", DepthWave, AgeWave, PolyOrder, YorN;
			G_DepthWave = DepthWave; G_AgeWave = AgeWave; G_PolyOrder = PolyOrder; G_YorN = YorN			
			AbortOnValue V_Flag, 0
			AgeDepthFit_F( Site, Folder, DepthWave, AgeWave,   PolyOrder  , YorN )
			Print "AgeDepthFit_F( " + "\"" + Site + "\", \"" + Folder + "\", \"" + DepthWave + "\", \"" + AgeWave + "\", ", PolyOrder, ", \"" + YorN + "\" )"
	End

----------------------------------------------------------------------

//	Function AgeDepthFit_F( Site, Folder, DepthWave, AgeWave, PolyOrder, YorN )
			String Site, Folder, AgeWave, DepthWave, YorN
			Variable PolyOrder	
		SetDataFolder root:$Folder
			Wave DW = $DepthWave, AW = $AgeWave
			If( WaveType( DW, 1 ) == 2 || WaveType( AW, 1 ) == 2 )
				SetDataFolder root:
				ABORT "Either " + AgeWave + " or " + DepthWave + " is a TEXT wave and can't be used for curve fitting.\r\rDelete the \"AgeDepthFit\" folder and run again."
			EndIf
			If( NumPnts( DW ) != NumPnts( AW ) )
				SetDataFolder root:
				ABORT AgeWave + " does not have the same number of points as " + DepthWave
			EndIf
		NewDataFolder/O/S $"root:AgeDepthFit"
			Duplicate/O DW $Site + "DepthWv"
			Duplicate/O AW $Site + "AgeWv"
			Duplicate/O AW $Site + "Weight"

			WAVE DepthWv = $Site + "DepthWv", AgeWv = $Site + "AgeWv", Weight = $Site + "Weight"
			Weight = 1

			Make/T/O/N = ( NumPnts( DepthWv ) ) $Site + "DataTypeWv"
			WAVE/T DataTypeWv = $Site + "DataTypeWv", MultiDataType = $Site + "_DataType_4_Fit"
			If( WaveExists( MultiDataType ) )
				DataTypeWv = MultiDataType
			Else
				DataTypeWv = SecondPart( DepthWave )
			EndIf

			If( StrSearch( WinList( "*", ";", "Visible:1" ), "Poly_Fit", 0 ) < 0 )
				Display/N = Poly_Fit /W = ( 431, 45, 952, 526 ) /B = AgeAxis /L = DepthAxis DepthWv vs AgeWv	as "Poly Fit"		
			Else
				EXECUTE "DoWindow/F Poly_Fit"
			EndIf
			If( StringMatch( YorN, "Yes" ) )
				InsertPoints 0, 1, DepthWv, AgeWv, Weight, DataTypeWv
				DataTYpeWv[0] = "Forced"
				Weight[ 0 ] = 1
				K0 = 0
				If( PolyOrder == 2 )
					CurveFit/Q/L=500/H="10" line, DepthWv /X=AgeWv /D /W = Weight
				Else
					CurveFit/Q/L=500/H="1000000000000" poly PolyOrder, DepthWv /X=AgeWv /D /W = Weight
				Endif
			Else
				If( PolyOrder == 2 )
					CurveFit/Q/L=500 line, DepthWv /X=AgeWv /D /W = Weight		
				Else
					CurveFit/Q/L=500 poly PolyOrder, DepthWv /X=AgeWv /D /W = Weight
				EndIf
			EndIf
			WAVE W_coef			

			Duplicate/O $"fit_" + Site + "DepthWv" $"fit_" + Site + "AgeWv", SedRateDepth
			Duplicate/O W_coef $"fit_" + Site + "Coefs"
			WAVE AgeFit = $"fit_" + Site + "AgeWv", DepthFit = $"fit_" + Site + "DepthWv"
			If( CheckAgeModel( AgeFit, DepthFit ) == 0 )
				DoAlert/T="Age Model Warning", 0, "The age/depth fit is recurved ( negative sed rates ).\r\rThis may cause a problem when converting depth to age.\r\r Either rerun with a different Order of fit or hand edit the fit curves."
			EndIf
			Differentiate DepthFit /D = SedRate
			If( PolyOrder == 2 )
				SedRate = Round( SedRate ) 
			EndIf
			If( StrSearch( TraceNameList( "", ";", 1 ), "SedRateDepth", 0 ) < 0 )
				AppendToGraph/T/L = DepthAxis SedRateDepth vs SedRate
				Label top "SedRate m/Myr";DelayUpdate
				ModifyGraph axisEnab(top)={0.5,1}
				ModifyGraph rgb(SedRateDepth)=(65535,43690,0)
			EndIf
			AgeFit = x
			SetAxis AgeAxis 0,*
			SetAxis/R DepthAxis *,0
			ModifyGraph mode($Site + "DepthWv")=3,marker($Site + "DepthWv")=19,msize($Site + "DepthWv")=5;DelayUpdate
			ModifyGraph mrkThick($Site + "DepthWv")=2,rgb($Site + "DepthWv")=(0,0,0), lsize = 2
			ModifyGraph freePos = 0
			Label DepthAxis "Depth";DelayUpdate
			Label AgeAxis "Age"
			ModifyGraph lblPos = 50
			ModifyGraph lblPosMode = 4
			ShowInfo
			KillWaves/Z W_ParamConfidenceInterval, W_sigma, W_coef
		SetDataFolder root:
			If( StrSearch( WinList( "*", ";", "Visible:1" ), "FittingData", 0 ) < 0 )
				Edit/N = FittingData AgeWv, DepthWv, DataTypeWv, Weight
				ModifyTable alignment=1
			EndIf
	End

---------------------------------------------------------------

//	Function ReFit()
		SetDataFolder root:
			Variable/G G_PolyOrder
			Variable PolyOrder = G_PolyOrder
			String/G G_Site
			String Site = G_Site		
			Prompt PolyOrder, "Order of Fit ( 2 or greater )"
			DoPrompt "ReFit", PolyOrder; 
			G_PolyOrder = PolyOrder
			AbortOnValue V_Flag, 0
		SetDataFolder AgeDepthFit
			WAVE AgeWv = $Site + "AgeWv", DepthWv = $Site + "DepthWv", Weight = $Site + "Weight"
			EXECUTE "DoWindow/F Poly_Fit"
			If( PolyOrder == 2 )
				CurveFit/Q/L=500 line, DepthWv /X=AgeWv /D	/W = Weight	
			Else
				CurveFit/Q/L=500 poly PolyOrder, DepthWv /X=AgeWv /D /W = Weight
			EndIf
			WAVE W_coef
			Duplicate/O $"fit_" + Site + "DepthWv" $"fit_" + Site + "AgeWv", SedRateDepth
			Duplicate/O W_coef $"fit_" + Site + "Coefs"
			WAVE AgeFit = $"fit_" + Site + "AgeWv", DepthFit = $"fit_" + Site + "DepthWv"
			If( CheckAgeModel( AgeFit, DepthFit ) == 0 )
				DoAlert/T="Age Model Warning", 0, "The age/depth fit is recurved ( negative sed rates ).\r\rThis may cause a problem when converting depth to age.\r\r Either rerun with a different Order of fit or hand edit the fit curves."
			EndIf
			Differentiate DepthFit /D = SedRate
			If( PolyOrder == 2 )
				SedRate = Round( SedRate ) 
			EndIf
			KillWaves/Z W_ParamConfidenceInterval, W_sigma, W_coef
		SetDataFolder root:
	End

---------------------------------------------------------

//	Function SetWeights()
		SetDataFolder root:AgeDepthFit
			String/G G_Site
			String Site = G_Site, DataTypeList
			Prompt Site, "Site"
			DoPrompt "SetWeights", Site;
			G_Site = Site
			AbortOnValue V_Flag, 0			
			Wave/T DataTypeWv = $Site + "DataTypeWv"
			Wave WeightWave = $Site + "Weight"
			DataTypeList = DataTypeWv[ 0 ] + ";"
			Variable i, NumberOfTypes = ItemsInList( DataTypeList )
			For( i = 0; i < NumPnts( DataTypeWv ); i += 1 )
				NumberOfTypes = ItemsInList( DataTypeList )				
				If( !StringMatch( DataTypeWv[ i ], StringFromList( NumberOfTypes - 1, DataTypeList ) ) )
					DataTypeList = DataTypeList + DataTypeWv[ i ] + ";"					
				EndIf				
			EndFor
			String/G G_DataType
			String DataType = G_DataType
			Variable/G G_WeightValue
			Variable WeightValue = G_WeightValue
			Prompt DataType, "Select the data type for weight change", popup, DataTypeList
			Prompt WeightValue, "Enter the new weight"
			DoPrompt "SetWeights", DataType, WeightValue
			G_DataType = DataType, G_WeightValue = WeightValue
			AbortOnValue V_Flag, 0
			WeightWave = StringMatch( DataType, DataTypeWv ) ? WeightValue : WeightWave
		SetDataFolder root:
	End