#pragma rtGlobals=1		// Use modern global access method.

// Last Change 03OCT16 RHW
	
	Function Append_Selected_Core_Images()
		SetDataFolder root:
			String/G  G_New_or_App, G_AxisName, G_XAxisName
			Variable/G G_AxisBottom, G_AxisTop
			String S1, S_Core, Hole, New_or_App = G_New_or_App
			String AxisName = G_AxisName, XAxisName = G_XAxisName
			Variable AxisBottom = G_AxisBottom, AxisTop = G_AxisTop
			Variable i = 0, FirstU, SecondU, Colon
			PauseUpdate;
			If( StrLen( GetBrowserSelection( 0 ) ) == 0 )
				ABORT "You forgot to select image waves in the Data Browser"
			EndIf

			S_Core =  GetBrowserSelection(0) // This sequence finds the Hole name for S2_ or K_ images used for axis name in new plots
			Colon = StrSearch( S_Core, ":" ,inf, 1 )
			Hole = S_Core[ Colon+1, inf ]
			FirstU = StrSearch( Hole, "_", 0 )						
			SecondU = StrSearch( Hole, "_", FirstU+1 )			
			Hole = Hole[ FirstU+1, SecondU-1 ]	

			Prompt New_or_App, "New Plot or Append?", popup, "New;Append"
			DoPrompt "Append_Selected_Core_Images", New_or_App; AbortOnValue V_Flag, 0
			G_New_or_App = New_or_App
			If( Stringmatch( "New", New_or_App ) )
				Preferences 1
				Display 
			ElseIf( StrLen( WinList( "*", ";", "WIN:1" ) ) == 0 )
				ABORT "You chose APPEND, but there are no open graphs."
			EndIf
			If( StringMatch( New_or_App, "New" ) )
				AxisName = Hole
				AxisTop = 100; AxisBottom = 0
				Prompt AxisName, "New Y Axis Name:"
				Prompt AxisTop, "Y Axis Portion Top (%):"
				Prompt AxisBottom, "Y Axis Portion Bottom (%):"
				Prompt XAxisName, "X Axis Name:", popup, "Depth;Age"
				DoPrompt "Append_Selected_Core_Images", AxisName, AxisBottom, AxisTop, XAxisName; AbortOnValue V_Flag, 0					
				G_AxisBottom = AxisBottom; G_AxisTop = AxisTop; G_AxisName = AxisName; G_XAxisName = XAxisName
			Else
				Prompt XAxisName, "X Axis Name:", popup, "Depth;Age"
				Prompt AxisName, "Select Y Axis or \"NewAxis\" to be Prompted for New Axis Name:", popup, "NewAxis;" + AxisList( "" )	
				Prompt AxisTop, "Y Axis Portion Top (%):"
				Prompt AxisBottom, "Y Axis Portion Bottom (%):"
				Prompt XAxisName, "X Axis Name:", popup, "Depth;Age"
				DoPrompt "Append_Selected_Core_Images", AxisName, AxisBottom, AxisTop, XAxisName; AbortOnValue V_Flag, 0
				G_AxisBottom = AxisBottom; G_AxisTop = AxisTop; G_AxisName = AxisName; G_XAxisName = XAxisName
				If( Stringmatch( AxisName, "NewAxis" ) )
					Prompt AxisName, "New Axis Name"
					DoPrompt "Append_Selected_Core_Images", AxisName
					G_AxisName = AxisName
				EndIf
			EndIf
			XAxisName = XAxisName+"Axis"
			Do
				S_Core = GetBrowserSelection( i )
				If( !StrLen( S_Core ) )
					Break
				EndIf
				Colon = StrSearch( S_Core, ":", inf, 1 )
				AppendImage/B = $XAxisName/L = $AxisName  $S_Core
				i+=1
			While( 1 )
			ModifyGraph freePos( $AxisName ) = 0
			ModifyGraph tick( $AxisName ) = 3, noLabel( $AxisName ) = 1, lblPos( $AxisName ) = 30
			ModifyGraph axisEnab( $AxisName ) = { AxisBottom/100, AxisTop/100 }
			ModifyGraph nticks($XAxisName)=10,minor($XAxisName)=1,freePos($XAxisName)=0
			Label $AxisName "\\Z12\\f01"+ AxisName
			SetAxis/A/R $AxisName
	EndMacro
	
	---------------------------------------

	Function Append_Spliced_Image(  ) 			
		SetDataFolder root:
			String/G G_Site, G_Axis_Portion, G_X_Scale, G_New_or_App, G_X_Axis_Pos, G_XAxisName
			Variable/G G_AxisBottom, G_AxisTop
			String Site = G_Site, Axis_Portion = G_Axis_Portion, X_Scale = G_X_Scale, X_Axis_Pos = G_X_Axis_Pos	//definition of X_Axis_Pos as a global variable G_S3 (was empty, but may need to rerun this with a specific global variable)
			String New_or_App = G_New_or_App, LAxisName, XAxisName = G_XAxisName
			Variable AxisBottom = G_AxisBottom, AxisTop = G_AxisTop
			Prompt Site, "Site"
			Prompt New_or_App, "New Plot or Append?", popup, "New;Append"	
			Prompt X_Scale, "X Scale", popup, "Depth;Age;Stretched"							// change X_scale request to be broader
			Prompt X_Axis_Pos, "X-Axis Postition", popup, "B;T"		//addition of prompt for X_Axis_Pos - but can't get it as a list (lose some of the text)
			Prompt AxisTop, "Axis Portion Top (%):"
			Prompt AxisBottom, "Axis Portion Bottom (%):"
			Prompt XAxisName, "XAxisName:", popup, "Depth;Age"
			DoPrompt "Append_Spliced_Image", Site, New_or_App, AxisBottom, AxisTop, X_Scale, X_Axis_Pos, XAxisName; AbortOnValue V_Flag, 0;
			G_AxisBottom = AxisBottom; G_AxisTop = AxisTop; G_X_Scale = X_Scale; G_New_or_App = New_or_App, G_X_Axis_Pos = X_Axis_Pos
			G_XAxisName = XAxisName; AbortOnValue V_Flag, 0;
			XAxisName = XAxisName + "Axis"
			If( ( Exists( Site + "_Splice" ) != 1 ) && StringMatch( X_Scale, "Depth" ) )
				ABORT "I can't find the splice image " + Site + "_Splice in root:"
			EndIf
			If( ( Exists( Site + "_Splice_Age" ) != 1 ) && StringMatch( X_Scale, "Age" ) )
				ABORT "I can't find the splice image " + Site + "_Splice_Age in root:"
			EndIf
			If( Stringmatch( "New", New_or_App ) )
				Preferences 1
				Display 
			ElseIf( StrLen( WinList( "*", ";", "WIN:1" ) ) == 0 )
					ABORT "You chose APPEND, but there are no open graphs."
			EndIf
			PauseUpdate;
			If( StringMatch( X_Scale, "Depth" ) )
				WAVE ImageW = $Site + "_Splice"	
				LAxisName = Site + "_Splice"
				If( StringMatch( "B", X_Axis_Pos ) )
					AppendImage/B = $XAxisName  /L = $LAxisName  ImageW		
				Else
					AppendImage/T = $XAxisName  /L = $LAxisName  ImageW		 		
				Endif
				ModifyGraph freePos( $LAxisName ) = 0
				Label $LAxisName " \\Z12\\f01"+Site
				ModifyGraph tick( $LAxisName ) = 3, noLabel( $LAxisName ) = 1, lblPos( $LAxisName ) = 30	
				ModifyGraph axisEnab( $Site + "_Splice" ) = { AxisBottom/100, AxisTop/100 }
			Else
				If( StringMatch( X_Scale, "Age" ) )															//Changed to Elseif to be specific to Age
					WAVE ImageW = $Site + "_Splice_Age"	
					LAxisName = Site + "_Age"
					If( StringMatch( "B", X_Axis_Pos ) )
						AppendImage/B = $XAxisName  /L = $LAxisName  ImageW		
					Else
						AppendImage/T = $XAxisName  /L = $LAxisName  ImageW		 		
					Endif
					ModifyGraph freePos( $LAxisName ) = 0
					ModifyGraph axisEnab( $LAxisName ) = { AxisBottom/100, AxisTop/100 }
					Label $LAxisName " \\Z12\\f01"+ Site + "_A"
					ModifyGraph tick( $LAxisName ) = 3, noLabel( $LAxisName ) = 1, lblPos( $LAxisName ) = 30	
				Else																		//Changed to Elseif to be specific to Age
					WAVE Stretched_Splice
					If( StringMatch( "B", X_Axis_Pos ) )
						AppendImage/B = $XAxisName  /L = Stretch  Stretched_Splice		
					Else
						AppendImage/T = $XAxisName  /L = Stretch  Stretched_Splice		 		
					Endif
					ModifyGraph freePos( Stretch ) = 0
					ModifyGraph axisEnab( Stretch  ) = { AxisBottom/100, AxisTop/100 }
					Label  Stretch " \\Z12\\f01"+ Site+"_S"
					ModifyGraph tick( Stretch ) = 3, noLabel( Stretch ) = 1, lblPos( Stretch ) = 30
				EndIf		
			EndIf
			ModifyGraph nticks($XAxisName)=10,minor($XAxisName)=1,freePos($XAxisName)=0
	EndMacro
	
	---------------------------------------
	
	// This older version works but only appends every core image from a hole. The user cannot select
	//		individual or sets of individual images
	
	Function Append_Core_Images( )
		SetDataFolder root:
			String/G G_Hole, G_New_or_App, G_Size
			Variable/G G_AxisBottom, G_AxisTop
			String Image, Hole = G_Hole, Size = G_Size, Folder, S_Core
			String New_or_App = G_New_or_App, WvList
			Variable i = 0, AxisBottom = G_AxisBottom, AxisTop = G_AxisTop
			Prompt Hole, "Hole"
			Prompt Size, "Size ( S1, S2, S3....)"
			Prompt AxisTop, "Axis Portion Top (%):"
			Prompt AxisBottom, "Axis Portion Bottom (%):"
			Prompt New_or_App, "New Plot or Append?", popup, "New;Append"	
			DoPrompt "Append_Core_Images", Hole, New_or_App, AxisBottom, AxisTop, Size; 
			G_Hole = Hole; G_New_or_App = New_or_App, G_Size = Size
			AbortOnValue V_Flag, 0;
			If( !StrLen( FolderList( Hole + "_" + Size ) ) )
				ABORT "There is no image folder " + Hole + "_" + Size
			EndIf
			Append_Core_Images_F( Hole, Size, AxisBottom, AxisTop, New_or_App )	
			Print "	Append_Core_Images_F( \"" + Hole + "\", \"" + Size + "\",", AxisBottom, ",", AxisTop, ",\"" + New_or_App + "\" )"
	End

--------------------------------------------------------------------------

	Function Append_Core_Images_F( Hole, Size, AxisBottom, AxisTop, New_or_App )
		String Hole, Size, New_or_APP
		Variable AxisBottom, AxisTop
		SetDataFolder root:
			String/G G_Hole, G_New_or_App
			Variable/G G_AxisBottom, G_AxisTop
			String Image, Folder, S_Core, WvList
			Variable i = 0
			G_Hole = Hole; G_AxisBottom = AxisBottom; G_AxisTop = AxisTop; G_New_or_App = New_or_App
			If( Stringmatch( "New", New_or_App ) )
				Preferences 1
				Display 
			ElseIf( StrLen( WinList( "*", ";", "WIN:1" ) ) == 0 )
				ABORT "You chose APPEND, but there are no open graphs."
			EndIf
		SetDataFolder $Hole + "_" + Size
			WvList = WaveList( "S*", ";", "DIMS:3" )
			For( i = 0; i < ItemsInList( WvList ); i += 1 )
				Image = StringFromList( i, WvList )
//				AppendImage/L = $Hole $Image
				AppendImage/B = DepthAxis/L = $Hole $Image
			EndFor
			ModifyGraph freePos( $Hole ) = 0
			Label $Hole "\\Z12\\f01" + Hole
			ModifyGraph tick( $Hole )=3,noLabel( $Hole ) =1,lblPos( $Hole )=30
			ModifyGraph axisEnab( $Hole ) = { AxisBottom/100, AxisTop/100 }
			SetAxis/A/R $Hole
			ModifyGraph nticks(bottom)=10,minor(bottom)=1
		SetDataFolder root:	
	End


