﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

// This function is paired with GridSetUP(). It duplicates rows of points at the level of the B cursor.

	Function Add_Rows_CsrB()
		SetDataFolder root:
			WAVE WaveX, WaveY // These waves were formed using the grid set up function
			Variable NumXPnts // This is the number of points in a row
			Duplicate/O WaveX Temp
			Differentiate Temp/D=Temp_DIF // Use differentiation to see where the first row of X values ends
			FindLevel/Q Temp_DIF, 0 // Where the x values have been duplicated to correspond to a different Y value the DIF goes negative 
			If( V_Flag == 1 ) // V_Flag = 1 is the case where only the initial X row is present, so there is no ngative DIF
				NumXPnts = NumPnts( WaveX ) // X points
				Concatenate/NP "Temp;", WaveX // Add another set of X points to WaveX
				Concatenate/NP "Temp;", WaveY // Add another set of X points to WaveX
				WaveY[ NumXPnts, Inf ] = VCsr( B ) // Reset the Y values to VCsr( B )
			Else // The case where a second ( or more ) row of X/Y coordinates already exist.
				NumXPnts = Ceil( V_LevelX ) + 1 // Finds where DIF goes negative and uses that to figure out number of x points in a row
				Duplicate/O/R = [ 0, NumXPnts - 1 ] WaveX, TempX, TempY // Create X and Y waves to add to WaveX and WaveY
				FindValue/T = 1/V = ( VCsr( B ) ) WaveY // Checking to see if the row already exists
				If( V_Value > -1 )
					DoAlert/T = "Possible Duplication" 1, "It looks like there are already grid points at the level of the B cursor.\r\rDid you forget to move the cursor?\r\rContinue?"
					AbortOnValue V_Flag == 2, 0
				EndIf
				TempY = VCsr( B ) // The Y coordiantes of the new row are set with the B cursor
				Concatenate/NP "TempX;", WaveX // Add X and Y for new row to grid
				Concatenate/NP "TempY;", WaveY			
			EndIf
			Killwaves/Z Temp, TempX, TempY, Temp_DIF
	End