﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	Function CryoMagJANUSDataLoader( )
		SetDataFolder root:
			Variable/G G_CC_Replacement
			Variable CC_Replacement = G_CC_Replacement
			Prompt CC_Replacement, "Replace CC's with column number used in Coring Matrix ( 9 is default )"
			DoPrompt "CryoMagJANUSDataLoader", CC_Replacement
			G_CC_Replacement = CC_Replacement; AbortOnValue V_Flag, 0
			Print "CryoMagJANUSDataLoader_F(",CC_Replacement,")"
			CryoMagJANUSDataLoader_F( CC_Replacement )
	End
	
	Function CryoMagJANUSDataLoader_F( CC_Replacement )
			Variable CC_Replacement
			String Hole
		SetDataFolder root:
			String SiteNum
			WAVE/T H, TW, Comment, Demag_Type, Treatment
			WAVE Leg,Site,Cor,Sc,Top_cm_,Depth__mbsf_,Level,Decl_,Incl_,Intensity,Hole_Incl_,Intensity_X,Intensity_Y,Intensity_Z,Run
			If( !WaveExists( Intensity ) )
				Print "I can't find the datawave \"Intensity\".\r\t\tDid you forget to copy the column label line along with the data?\r\t\t\t\tOR\r\t\tAre you sure the data are CryoMag data from JANUS?"
				ABORT "I can't find the datawave \"Intensity\".\r\rDid you forget to copy the column label line along with the data?\r\rOR\r\rAre you sure the data are CryoMag data from JANUS?"
			EndIf
			If( NumType( Cor[0] ) == 2 ) // Checks to see if the first line in the DataTable is blank
				DeletePoints 0,1,   H, TW, Comment, Demag_Type, Treatment, Leg,Site,Cor,Sc,Top_cm_,Depth__mbsf_,Level,Decl_,Incl_,Intensity,Hole_Incl_,Intensity_X,Intensity_Y,Intensity_Z,Run
			EndIf
			If( StrSearch( WinList( "*", ";", "WIN:2" ), "JANUSDataTable", 0 ) < 0  || StrSearch( WaveList( "*", ",", "WIN:JANUSDataTable" ), "Intensity", 0 ) < 0 ) // Checks that the data are in the designated Table named "JANUSDataTable"
				Print "The data are not in a table named \"JANUSDataTable\". \r\t\tKill the data waves you just pasted and Run:\r\t\t\t\tEmptyJANUSDataTable()\r\t\tfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\t\tAfter the first run the table will open automatically."
				ABORT "The data are not in a table named \"JANUSDataTable\". \r\rKill the data waves you just pasted and Run:\r\r\"EmptyJANUSDataTable\"\r\rfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\rAfter the first run the table will open automatically."
			Endif
			Hole = "U" + Num2Str( Site[ 0 ] ) + H[ 0 ]
			SiteNum = "U" + Num2Str( Site[ 0 ] )
			NewDataFolder/O $SiteNum + "_CryoMag"
			Replace_NaNswithNumber_F( "Sc", CC_Replacement )
			Duplicate/O H, $":" + SiteNum + "_CryoMag:" + Hole + "_CryoMag_Hole"; 
			Duplicate/O Cor, $":" + SiteNum + "_CryoMag:" + Hole + "_CryoMag_Core"; 
			Duplicate/O TW, $":" + SiteNum + "_CryoMag:" + Hole + "_CryoMag_Type"; 
			Duplicate/O Sc, $":" + SiteNum + "_CryoMag:" + Hole + "_CryoMag_Section"; 
			Duplicate/O Top_cm_, $":" + SiteNum + "_CryoMag:" + Hole + "_CryoMag_Interval"; 
			Duplicate/O Depth__mbsf_, $":" + SiteNum + "_CryoMag:" + Hole + "_CryoMag_mbsf"; 
			Duplicate/O Level, $":" + SiteNum + "_CryoMag:" + Hole + "_CryoMag_Level"
			Duplicate/O Decl_, $":" + SiteNum + "_CryoMag:" + Hole + "_CryoMag_Decl"
			Duplicate/O Incl_, $":" + SiteNum + "_CryoMag:" + Hole + "_CryoMag_Incl"
			Duplicate/O Intensity, $":" + SiteNum + "_CryoMag:" + Hole + "_CryoMag_Intensity"
			Duplicate/O Hole_Incl_, $":" + SiteNum + "_CryoMag:" + Hole + "_CryoMag_HoleIncl"
			Duplicate/O Intensity_X, $":" + SiteNum + "_CryoMag:" + Hole + "_CryoMag_IntensityX"
			Duplicate/O Intensity_Y, $":" + SiteNum + "_CryoMag:" + Hole + "_CryoMag_IntensityY"
			Duplicate/O Intensity_Z, $":" + SiteNum + "_CryoMag:" + Hole + "_CryoMag_IntensityZ"
			Duplicate/O Run, $":" + SiteNum + "_CryoMag:" + Hole + "_CryoMag_Run"
			Duplicate/O Treatment, $":" + SiteNum + "_CryoMag:" + Hole + "_CryoMag_Treatment"
			Duplicate/O Demag_Type, $":" + SiteNum + "_CryoMag:" + Hole + "_CryoMag_Demag_Type"
			Duplicate/O H, $":" + SiteNum + "_CryoMag:" + Hole + "_CryoMag_Site"; 
			WAVE/T SiteWv = $":" + SiteNum + "_CryoMag:" + Hole + "_CryoMag_Site"
			SiteWv = SiteNum
			EmptyJANUSDataTable( )
			KillWaves H, TW, Comment, Demag_Type, Treatment
			KillWaves Leg,Site,Cor,Sc,Top_cm_,Depth__mbsf_,Level,Decl_,Incl_,Intensity,Hole_Incl_,Intensity_X,Intensity_Y,Intensity_Z,Run
		SetDataFolder $SiteNum + "_CryoMag" // This last it sorts the data by demag level and Core, Section, Interval
			EXECUTE "Sort {" + Hole + "_CryoMag_Level," + Hole + "_CryoMag_Core," + Hole + "_CryoMag_Section," + Hole + "_CryoMag_Interval}, " + WaveList(Hole+"*",",","")	
		SetDataFolder root:
	End
