#pragma rtGlobals=3		// Use modern global access method and strict wave access.
		
// This function creates tale of data for a given hole and technique ( data folder )
// If the table is already open it is moved to the front.

	Function Make_DataTable()
		SetDataFolder root:
			String/G G_Hole, G_Folder
			String Hole = G_Hole, Folders, Folder = G_Folder
			Folders = "root:;" + FolderList( "*" ) 
			Prompt Hole, "Hole or Splice ( e.g. U1338A or U1338_Splice )"
			Prompt Folder, "Data Folder", popup, SortList( Folders )
			DoPrompt "Make_DataTable", Hole, Folder; AbortOnValue V_Flag, 0
			Make_DataTable_F( Hole, Folder )
			Print "Make_DataTable_F( \"" + Hole +"\", \"" + Folder + "\" )"
	End

-------------------------------------------------------------------------------
	
	Function Make_DataTable_F( Hole, Folder )
		String Hole, Folder
		SetDataFolder root:
			String/G G_Hole = Hole, G_Folder = Folder
			String Technique = Folder[ StrSearch( Folder, "_", 0 ) + 1, inf ]
			String Folders, WList, Wv, TableName = UpperStr( Hole ) + "_" + Technique + "_Data"
					// CapsList is a list, in order, of possible waves that come before the rest of the data in the table
			String CapsList = "Site;Hole;Core;Type;Section;Interval;CSF;CSFA;CSF-A;mbsf;CCSF;CCSFA;CCSF-A;mcd;rmcd"
			String Cap
			Variable i
			Folders = "root:;" + FolderList( "*" ) 
			If( Strlen( WinList( TableName, ";", "Visible:1" ) ) == 0 )
				Edit/W=(576,67,1557,526)/N = $TableName as TableName; // Opens blank table
			Else
				DoWindow/F DataTable
			EndIf
		SetDataFolder $Folder
			WList = SortList( WaveList( Hole + "*", ";", "" ) ) // List of data waves from the selected hole
			WList = RemoveFromList( Hole + "_Coring_Matrix", WList ) // Skips matrices if "root:" is selected as the data folder
			WList = RemoveFromList( Hole + "_Offsets", WList ) // Skips offsets if "root:" is selected as the data folder
			For( i = 0; i < ItemsInList( CapsList ); i += 1 ) // This loop appends core, section, interval etc to the front of the table
				WAVE/Z W = $Hole + "_" + Technique + "_" + StringFromList( i, CapsList )
				If( WaveExists( W ) )
					AppendToTable W
				Endif
			EndFor
			For( i = 0; i < ItemsInList( WList ); i += 1 ) // This loop adds the rest of the data in alphabetical order
				WAVE W = $StringFromList( i, WList )
				AppendToTable W
			EndFor
			For( i = 0; i < ItemsInList( WList ); i += 1 ) // Formatting for the table
				Wv = StringFromList( i, WList )
				If( StrSearch( Wv, "Section", 0, 2 ) > 0 || StrSearch( Wv, "Core", 0, 2 ) > 0 || StrSearch( Wv, "Interval", 0, 2 ) > 0 )
					ModifyTable format($Wv)=1
				EndIf
			EndFor
			ModifyTable alignment = 1	
		SetDataFolder root:
	End
	
-------------------------------------------------------------------------------
	
//	Function Make_DataTable_F( Hole, Folder )
		String Hole, Folder
		SetDataFolder root:
			String/G G_Hole = Hole, G_Folder = Folder
			String Technique = Folder[ StrSearch( Folder, "_", 0 ) + 1, inf ]
			String Folders, WList, Wv
					// CapsList is a list, in order, of possible waves that come before the rest of the data in the table
			String CapsList = "Site;Hole;Core;Type;Section;Interval;CSF;CSFA;CSF-A;mbsf;CCSF;CCSFA;CCSF-A;mcd;rmcd"
			String Cap
			Variable i
			Folders = "root:;" + FolderList( "*" ) 
			If( Strlen( WinList( "DataTable", ";", "Visible:1" ) ) == 0 )
				Edit/W=(576,67,1557,526)/N = DataTable as "DataTable"; // Opens blank table
			Else
				DoWindow/F DataTable
			EndIf
		SetDataFolder $Folder
			WList = SortList( WaveList( Hole + "*", ";", "" ) ) // List of data waves from the selected hole
			WList = RemoveFromList( Hole + "_Coring_Matrix", WList ) // Skips matrices if "root:" is selected as the data folder
			WList = RemoveFromList( Hole + "_Offsets", WList ) // Skips offsets if "root:" is selected as the data folder
			For( i = 0; i < ItemsInList( CapsList ); i += 1 ) // This loop appends core, section, interval etc to the front of the table
				WAVE/Z W = $Hole + "_" + Technique + "_" + StringFromList( i, CapsList )
				If( WaveExists( W ) )
					AppendToTable W
				Endif
			EndFor
			For( i = 0; i < ItemsInList( WList ); i += 1 ) // This loop adds the rest of the data in alphabetical order
				WAVE W = $StringFromList( i, WList )
				AppendToTable W
			EndFor
			For( i = 0; i < ItemsInList( WList ); i += 1 ) // Formatting for the table
				Wv = StringFromList( i, WList )
				If( StrSearch( Wv, "Section", 0, 2 ) > 0 || StrSearch( Wv, "Core", 0, 2 ) > 0 || StrSearch( Wv, "Interval", 0, 2 ) > 0 )
					ModifyTable format($Wv)=1
				EndIf
			EndFor
			ModifyTable alignment = 1	
		SetDataFolder root:
	End
	
