﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	
	Function ProcessTies()
		SetDataFolder root:
			DoWindow/F TuningGraph
			WAVE CoreTies, TargetTies  //  These 2 waves are in root and hold the ties between the target and the data
			WAVE TargetWave = CsrWaveRef( a ) // These 4 lines set wave refs for Target & Data x and y waves
			WAVE TargetAgeWave = CsrXWaveRef( a )
			WAVE CoreWave = CsrWaveRef( b )
			WAVE CoreAgeWave = CsrXWaveRef( b )
			DFREF DataFolder = GetWavesDataFolderDFR( CoreWave )
			String GraphWaves = TraceNameList( "", ";", 1 )  // This is a list of traces plotted in the tuning graph
		SetDataFolder DataFolder
			Duplicate/O CoreAgeWave $S_Csr_Hole("b") + "_" + S_Csr_Technique("b") + "_AgeTarget"  // Set up a wave to hold the data ages interpolated from the target
			WAVE CoreTargetAge = $S_Csr_Hole("b") + "_" + S_Csr_Technique("b") + "_AgeTarget"
			CoreTargetAge = interp( CoreAgeWave, CoreTies, TargetTies ) //  Do the interpolation			
		NewDataFolder/O/S root:Xtras
			Duplicate/O  CoreTies TargetTieVals, CoreTieVals, TieNumber  //  These waves were set initially
			TieNumber = X
		SetDataFolder root:
			TargetTieVals = Interp( TargetTies, TargetAgeWave, TargetWave )
			CoreTieVals = Interp( CoreTies, CoreAgeWave, CoreWave )
			CoreTargetAge = CoreTargetAge <= WaveMax( TargetTies ) ? CoreTargetAge : NaN
			If( ! StringMatch( GraphWaves, "*" + NameOfWave( CoreWave ) + "#1*" ) )
				AppendToGraph/L=MatchAxis CoreWave vs CoreTargetAge
			EndIf
			If( ! StringMatch( GraphWaves, "*" + "CoreTieVals*" ) )
				AppendToGraph/L=DataAxis :Xtras:CoreTieVals vs CoreTies
				AppendToGraph/L = TargetAxis :Xtras:TargetTieVals vs TargetTies
				ModifyGraph mode(CoreTieVals)=3,textMarker(CoreTieVals)={:Xtras:TieNumber,"default",0,0,5,0,10}
				ModifyGraph mode(TargetTieVals)=3,textMarker(TargetTieVals)={:Xtras:TieNumber,"default",0,0,5,0,10}
				ModifyGraph minor(bottom)=1, msize(CoreTieVals)=5, msize(TargetTieVals)=5
				ModifyGraph rgb(CoreTieVals)=(0,52428,0), rgb(TargetTieVals)=(0,52428,0)
			EndIf
			CalculateCoreSedRates()
	End
