﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

// This function checks to be sure that the numbor of offsets is equal to the number of cores.

	Function CheckOffsets_CoreNumbers( Hole )
		String Hole
		String/G G_Offsets
		SetDataFolder root:
			WAVE/Z Matrix = $Hole + "_Coring_Matrix", Offsets = $Hole + "_Offsets"
			If( !WaveExists( Matrix ) )
				ABORT "I can't find " + Hole + "_Coring_Matrix"
			EndIf
			If( DimSize( Offsets, 0 ) != DimSize( Matrix, 0 ) )
				DoAlert/T = "Offsets not equal to cores", 0, "The number of cores and the number of offsets may not be the same.\r\rSee \"History\" for suggestions."
				Print "\rThe number of cores and the number of offsets may not be the same."
				Print "Several problems may have caused this error:"
				Print "1 - You started the offets on line 0 instead of line 1 ( line 0 should be a NaN )."
				Print "2 - If you copied the offsets from a table there may be offsets missing for cores with no recovery.\r\t\t\t\tCheck to be sure that the core numbers in the table are consecutive."
				Print "3 - Offsets were not recorded for the lowermost cores. Set the offsets for those cores to the deepest offset recoded."
				Print "4 - Older matrices may have 100 rows by default.\r\t\t\t\tCut the uneeded rows from the matrix.\r"
			Endif
	End

