#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	
	*********************************************************
	
	Function Site_2_Site_Image_SetUp( )
		SetDataFolder root:
			PauseUpdate;
			String BaseSite, StretchSite; 
			String/G G_BaseSite, G_StretchSite
			BaseSite = G_BaseSite, StretchSite = G_StretchSite
			Prompt BaseSite "BaseSite"
			Prompt StretchSite "StretchSite"
			DoPrompt "Site_2_Site_Image_SetUp" BaseSite, StretchSite
			G_BaseSite = BaseSite; G_StretchSite = StretchSite
			AbortOnValue V_Flag, 0
			String StretchedName = StretchSite + "_2_" + BaseSite +"_Str"		
			Duplicate/O $BaseSite + "_Splice" $StretchedName
			WAVE Stretched_Image = $StretchedName
			Stretched_Image = NaN
			Display/W=(81,45,987,374); ShowInfo

			If( !Exists("BaseTies"))			// to make BaseTies and StretchTies if these do not already exist (e.g. if you run the S2S_Data_SetUp first, rather than the image setup first)
				Make/O/N=0  BaseTies, StretchTies, TieStr, DeltaTies
				Make/O/N=0/T TieType
			EndIf 
			If( strlen ( winlist( "TieTable", "","" ) ) < 1 )
				Edit/N = TieTable BaseTies, StretchTies, TieType, TieStr, DeltaTies as "TieTable"
			EndIf
			WAVE BaseTies, StretchTies, TieStr, DeltaTies
			WAVE/T TieType
		
			AppendImage/T/L = $StretchedName Stretched_Image									// Appended to top axis
			Label $StretchedName "\\Z12\\f01" + StretchSite + " Stretched"
			ModifyGraph lblPos( $StretchedName ) = 30, freePos( $StretchedName ) = 0
			ModifyGraph axisEnab( $StretchedName ) = { .66, 1 }
			ModifyGraph tick( $StretchedName ) = 3, noLabel ( $StretchedName ) = 1
			
			WAVE StrImage = $StretchSite + "_Splice"
			AppendImage/L = $StretchSite StrImage
			Label $StretchSite "\\Z12\\f01" + StretchSite
			ModifyGraph lblPos( $StretchSite ) = 30, freePos( $StretchSite ) = 0
			ModifyGraph axisEnab( $StretchSite ) = { .0, .32 }
			ModifyGraph tick( $StretchSite ) = 3, noLabel ( $StretchSite ) = 1
	
			WAVE BaseImage = $BaseSite + "_Splice"
			AppendImage/T/L = $BaseSite BaseImage														// Appended to top axis
			Label $BaseSite "\\Z12\\f01" + BaseSite
			ModifyGraph lblPos( $BaseSite ) = 30, freePos( $BaseSite ) = 0
			ModifyGraph axisEnab( $BaseSite ) = { .33, .65 }
			ModifyGraph tick( $BaseSite ) = 3, noLabel ( $BaseSite ) = 1
 
 		NewDataFolder/O/S Xtras
			DFREF XtrasFldr = GetDataFolderDFR( )
			Make/O/N=0  Ones, Numbers	
			AppendToGraph/L = $StretchSite  Ones vs StretchTies
			AppendToGraph/T/L = $BaseSite  Ones vs BaseTies
			ModifyGraph mode=3, textMarker = { Numbers, "default", 0, 0, 5, 0.00, 0.00 }

		NewDataFolder/O/S $"root:" + BaseSite + "_" + StretchSite + "_Results" 
			If( Exists( BaseSite + "_2_" + StretchSite + "_Ties" ) )   // Copies existing Ties into generic BaseTies and StretchTies waves
				Duplicate/O $BaseSite + "_2_" + StretchSite + "_Ties" BaseTies
				Duplicate/O $StretchSite + "_2_" + BaseSite + "_Ties" StretchTies
				Duplicate/O/T $StretchSite + "_2_" + BaseSite + "_TieType" TieType
				Duplicate/O BaseTies Ones, Numbers
				Ones = .5
				Numbers = x
			EndIf

		SetDataFolder root:
			SetAxis Bottom 0, 30; SetAxis/Z Top 0, 30;		
			Cursor/I A, $BaseSite + "_Splice", LeftX( $BaseSite + "_Splice" ), 0.5
			Cursor/I B, $StretchSite + "_Splice", LeftX( $StretchSite + "_Splice" ), 0.5
			Set_Cursors_Red( )			
			Label Bottom "\\Z14Stretch Site Original Depth"
			Label Top "\\Z14Base Site & Stretched Depth"	
			ModifyGraph lblMargin(top)=10,lblMargin(bottom)=10
			ModifyGraph nticks(top)=10,minor(top)=1
			ModifyGraph nticks(bottom)=10,minor(bottom)=1
	EndMacro	
	
	*********************************************************
