﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	Function AddPeriodTicks( )
		SetDataFolder root:
			String/G G_TickPeriods
			String TickPeriods = G_TickPeriods		
			Prompt TickPeriods, "List Semicolon separated ky Tick Periods, ( e.g. 21;41;100 )"
			DoPrompt "AddPeriodTicks", TickPeriods
			G_TickPeriods = TickPeriods
			AbortOnValue V_Flag, 0
			NewDataFolder/O root:Xtras:PeriodTicks // Make a folder in Xtras to hold the period dick data
			Make/O/T/N = ( ItemsInList( TickPeriods ) ) root:Xtras:PeriodTicks:PeriodTickText // Create a text wave for the periods requested by the User
			Make/O/N = ( ItemsInList( TickPeriods ) ) root:Xtras:PeriodTicks:PeriodTickValue // Create a wave to hold the frequencies of the requested ticks
			WAVE/T PeriodTickText = $"root:Xtras:PeriodTicks:PeriodTickText" // Wave refs for the above
			WAVE PeriodTickValue = $"root:Xtras:PeriodTicks:PeriodTickValue"
			Variable i
			For( i = 0; i < ItemsInList( TickPeriods ); i += 1 )
				PeriodTickText[ i ] = StringFromList( i, TickPeriods ) // Make each item in the tick period list into a value in the text wave
				PeriodTickValue[ i ] = 1000 / Str2Num( StringFromList( i, TickPeriods ) ) // Calculate the freq value for the periods based on my scaling 
			EndFor	
			If( StringMatch( WinName(0,1), "NormAmpFreq" ) )
				NewFreeAxis/O/T PeriodTickAxis // If freq is the bottom axis, put the ticks on a new top axis
			ElseIf( StringMatch( WinName(0,1), "NormAmpAge" ) )
				NewFreeAxis/O/R PeriodTickAxis // If age is the bottom axis, put the ticks on a new right axis
			EndIf
			ModifyFreeAxis PeriodTickAxis, Master = FreqAxis // Set the master axis for the tick axis
			ModifyGraph userticks(PeriodTickAxis)={PeriodTickValue,PeriodTickText} // add the ticks. The rest of the commands are formatting
			ModifyGraph mirror(FreqAxis)=0
			ModifyGraph freePos(PeriodTickAxis)=0
			Label PeriodTickAxis "Period"
			ModifyGraph lblPosMode(PeriodTickAxis)=4,lblPos(PeriodTickAxis)=40
			ModifyGraph axisEnab(PeriodTickAxis)={0,0.8}
	End
	
	Function RemovePeriodTicks()
		KillFreeAxis PeriodTickAxis
	End