#pragma rtGlobals=3		// Use modern global access method and strict wave access.
	
	
	
	Function Splice_Interval_Table( )
		String Site
		String fldrSav0 = GetDataFolder(1)		
		SetDataFolder root:
			String/G G_Site
			Site = G_Site
			Prompt Site, "Site"
			DoPrompt "Splice_Interval_Table", Site; 
			Print "Splice_Interval_Table_F( \"" + Site + "\" )"
			AbortOnValue V_Flag, 0
			Splice_Interval_Table_F( Site )
		SetDataFolder fldrSav0
	End

---------------------------------------------------------------------------------------------------------------------------------------	
	
	Function Splice_Interval_Table_F( Site )
		String Site
		String fldrSav0 = GetDataFolder(1)		
		SetDataFolder root:
			String/G G_Site
			G_Site = Site
		NewDataFolder/O/S $Site+"_Splice_Intervals"
			If( ItemsInLIst( WaveList( "*", ";", "" ) ) == 0 )
				Make_Splice_Interval_Waves()
			EndIf
	//  Forms the data table for the chosen site.
			WAVE  Core_Top, Section_Top, Interval_Top, CSF_Top, CCSF_Top
			WAVE/T Site_Top, Hole_Top, Type_Top, TIE//, Comment
			WAVE Section_Bottom, Interval_Bottom, CSF_Bottom, CCSF_Bottom
			KillWindow/Z $Site + "_Splice_Intervals" // Kills earlier versions of the table
			Edit/N=$Site + "_Splice_Intervals"/W=(753,157,1890,718) 
			AppendToTable Site_Top, Hole_Top, Core_Top, Type_Top, Section_Top, Interval_Top
			AppendToTable CSF_Top, CCSF_Top, Section_Bottom, Interval_Bottom, CSF_Bottom, CCSF_Bottom, TIE//, Comment
			ModifyTable format(Point)=1,alignment(Site_Top)=1,format(Site_Top)=3,digits(Site_Top)=2
			ModifyTable alignment(Hole_Top)=1,format(Hole_Top)=3,digits(Hole_Top)=2,alignment(Core_Top)=1
			ModifyTable format(Core_Top)=1,digits(Core_Top)=2,alignment(Type_Top)=1,format(Type_Top)=3
			ModifyTable digits(Type_Top)=2,alignment(Section_Top)=1,format(Section_Top)=1,digits(Section_Top)=2
			ModifyTable alignment(Interval_Top)=1,format(Interval_Top)=1,digits(Interval_Top)=2
			ModifyTable alignment(CSF_Top)=1,format(CSF_Top)=3,digits(CSF_Top)=2,alignment(CCSF_Top)=1
			ModifyTable format(CCSF_Top)=3,digits(CCSF_Top)=2,alignment(Section_Bottom)=1,format(Section_Bottom)=1
			ModifyTable digits(Section_Bottom)=2,alignment(Interval_Bottom)=1,format(Interval_Bottom)=1
			ModifyTable digits(Interval_Bottom)=2,alignment(CSF_Bottom)=1,format(CSF_Bottom)=3
			ModifyTable digits(CSF_Bottom)=2,alignment(CCSF_Bottom)=1,format(CCSF_Bottom)=3
			ModifyTable digits(CCSF_Bottom)=2
		SetDataFolder fldrSav0
	EndMacro
	
---------------------------------------------------------------------------------------------------------------------------------------	
	
	Function Splice_Tie_Table( )
		String Site
		String fldrSav0 = GetDataFolder(1)		
		SetDataFolder root:
			String/G G_Site
			Site = G_Site
			Prompt Site, "Site"
			DoPrompt "Splice_Tie_Table", Site
			Print "Splice_Tie_Table_F( \"" + Site + "\" )"
			AbortOnValue V_Flag, 0
			Splice_Tie_Table_F( Site )
		SetDataFolder fldrSav0
	End

---------------------------------------------------------------------------------------------------------------------------------------	
	
	Function Splice_Tie_Table_F( Site )
		String Site
		String fldrSav0 = GetDataFolder(1)		
		SetDataFolder root:
			String/G G_Site
			G_Site = Site
		NewDataFolder/O/S $Site+"_Splice_Ties"
			If( ItemsInLIst( WaveList( "*", ";", "" ) ) == 0 )
				Make_Splice_Tie_Waves()
			EndIf	
		//  Forms the data table for the chosen site.
		WAVE  Core_Top, Section_Top, Interval_Top, CSF_Top, CCSF_Top, Core_Bottom
		WAVE/T Site_Top, Hole_Top, Type_Top, Site_Bottom, Hole_Bottom, Type_Bottom, TIE
		WAVE  Section_Bottom, Interval_Bottom, CSF_Bottom, CCSF_Bottom
		KillWindow/Z $Site + "_Splice_Ties" // Kills earlier versions of the table
		Edit/N=$Site + "_Splice_Ties"/W=(753,157,1890,718) 
		AppendToTable Site_Bottom, Hole_Bottom, Core_Bottom, Type_Bottom, Section_Bottom
		AppendToTable Interval_Bottom, CSF_Bottom, CCSF_Bottom, TIE
		AppendToTable Site_Top, Hole_Top, Core_Top, Type_Top, Section_Top, Interval_Top, CSF_Top,  CCSF_Top
		ModifyTable format(Point)=1,alignment(Site_Bottom)=1,alignment(Hole_Bottom)=1,alignment(Core_Bottom)=1
		ModifyTable alignment(Type_Bottom)=1,alignment(Section_Bottom)=1,alignment(Interval_Bottom)=1
		ModifyTable alignment(CSF_Bottom)=1,alignment(CCSF_Bottom)=1,alignment(TIE)=1,alignment(Site_Top)=1
		ModifyTable format(Site_Top)=3,digits(Site_Top)=2,alignment(Hole_Top)=1,alignment(Core_Top)=1
		ModifyTable alignment(Type_Top)=1,alignment(Section_Top)=1,alignment(Interval_Top)=1
		ModifyTable alignment(CSF_Top)=1,alignment(CCSF_Top)=1
		ModifyTable format(Interval_Bottom)=1,format(CSF_Bottom)=3,digits(CSF_Bottom)=2;DelayUpdate
		ModifyTable format(CCSF_Bottom)=3,digits(CCSF_Bottom)=2,format(Interval_Top)=1;DelayUpdate
		ModifyTable format(CSF_Top)=3,digits(CSF_Top)=2,format(CCSF_Top)=3;DelayUpdate
		ModifyTable digits(CCSF_Top)=2
		ModifyTable format(Core_Bottom)=1,format(Section_Bottom)=1;DelayUpdate
		ModifyTable format(Core_Top)=1,format(Section_Top)=1
		SetDataFolder fldrSav0
	EndMacro

---------------------------------------------------------------------------------------------------------------------------------------	
	
	Function Make_Splice_Interval_Waves()
		String Wave_List, S1
		Variable i = 0
		Make/O/N = 1 Section_Bottom, Interval_Bottom, CSF_Bottom, CCSF_Bottom
		Make/O/N = 1 Core_Top, Section_Top, Interval_Top, CSF_Top, CCSF_Top
		Make/T/O/N = 1 Site_Top, Hole_Top, Type_Top, TIE, Comment
		Wave_List = WaveList( "*", ";", "TEXT:0" )
		Do
			S1 = StringfromList( i, Wave_List )
			WAVE W1 = $S1
				If( StrLen( S1 ) < 2 )
					Break;
				EndIf
			W1 = nan
			i += 1
		While( 1 )
	End

---------------------------------------------------------------------------------------------------------------------------------------	
	
	Function Make_Splice_Tie_Waves()
		String Wave_List, S1
		Variable i = 0
		Make/O/N = 1 Core_Bottom, Section_Bottom, Interval_Bottom, CSF_Bottom, CCSF_Bottom
		Make/O/N = 1 Core_Top, Section_Top, Interval_Top ,CSF_Top, CCSF_Top
		Make/T/O/N = 1 Site_Top, Hole_Top, Type_Top, TIE, Site_Bottom, Hole_Bottom, Type_Bottom
		Wave_List = WaveList( "*", ";", "TEXT:0" )
		Do
			S1 = StringfromList( i, Wave_List )
			WAVE W1 = $S1
				If( StrLen( S1 ) < 2 )
					Break;
				EndIf
			W1 = nan
			i += 1
		While( 1 )
	End

	